Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang.reflect
Class Constructor

    java.lang.Object
      java.lang.reflect.AccessibleObject
          java.lang.reflect.Constructor

All Implemented Interfaces:
  Member

public final class Constructor
extends AccessibleObject
implements Member

`Constructor` provides information about, and access to, a single constructor for a class.

`Constructor` permits widening conversions to occur when matching the actual parameters to newInstance() with the underlying constructor's formal parameters, but throws an `IllegalArgumentException` if a narrowing conversion would occur.

See Also:
  `Member`, `Class`, `Class.getConstructors()`, `Class.getConstructor(Class[])`, `Class.getDeclaredConstructors()`

Field Summary

Fields inherited from interface java.lang.reflect.Member
`DECLARED, PUBLIC`

Method Summary
`boolean` | `equals(Object obj)` Compares this `Constructor` against the specified object.
`Class` | `getDeclaringClass()` Returns the `Class` object representing the class that declares the constructor represented by this `Constructor` object.
`Class[]` | `getExceptionTypes()` Returns an array of `Class` objects that represent the types of of exceptions declared to be thrown by the underlying constructor represented by this `Constructor` object.
`int` | `getModifiers()` Returns the Java language modifiers for the constructor represented by this `Constructor` object, as an integer.
`String` | `getName()` Returns the name of this constructor, as a string.
`Class[]` | `getParameterTypes()` Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the constructor represented by this `Constructor` object.
`int` | `hashCode()` Returns a hashcode for this `Constructor`.
`Object` | `newInstance(Object[] initargs)` Uses the constructor represented by this `Constructor` object to create and initialize a new instance of the constructor's declaring class, with the specified initialization parameters.
`String` | `toString()` Returns a string describing this `Constructor`.

Methods inherited from class java.lang.reflect.AccessibleObject
`isAccessible, setAccessible, setAccessible`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### getDeclaringClass

    public Class getDeclaringClass()

  Returns the `Class` object representing the class that declares the constructor represented by this `Constructor` object.

  Specified by:
    `getDeclaringClass` in interface `Member`
  Returns:
    an object representing the declaring class of the underlying member

### getName

    public String getName()

  Returns the name of this constructor, as a string. This is always the same as the simple name of the constructor's declaring class.

  Specified by:
    `getName` in interface `Member`
  Returns:
    the simple name of the underlying member

### getModifiers

    public int getModifiers()

  Returns the Java language modifiers for the constructor represented by this `Constructor` object, as an integer. The `Modifier` class should be used to decode the modifiers.

  Specified by:
    `getModifiers` in interface `Member`
  Returns:
    the Java language modifiers for the underlying member
  See Also:
    `Modifier`

### getParameterTypes

    public Class[] getParameterTypes()

  Returns an array of `Class` objects that represent the formal parameter types, in declaration order, of the constructor represented by this `Constructor` object. Returns an array of length 0 if the underlying constructor takes no parameters.

  Returns:
    the parameter types for the constructor this object represents

### getExceptionTypes

    public Class[] getExceptionTypes()

  Returns an array of `Class` objects that represent the types of of exceptions declared to be thrown by the underlying constructor represented by this `Constructor` object. Returns an array of length 0 if the constructor declares no exceptions in its `throws` clause.

  Returns:
    the exception types declared as being thrown by the constructor this object represents

### equals

    public boolean equals(Object obj)

  Compares this `Constructor` against the specified object. Returns true if the objects are the same. Two `Constructor` objects are the same if they were declared by the same class and have the same formal parameter types.

  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the reference object with which to compare.
  Returns:
    `true` if this object is the same as the obj argument; `false` otherwise.
  See Also:
    `Object.hashCode()`, `Hashtable`

### hashCode

    public int hashCode()

  Returns a hashcode for this `Constructor`. The hashcode is the same as the hashcode for the underlying constructor's declaring class name.

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.
  See Also:
    `Object.equals(java.lang.Object)`, `Hashtable`

### toString

    public String toString()

  Returns a string describing this `Constructor`. The string is formatted as the constructor access modifiers, if any, followed by the fully-qualified name of the declaring class, followed by a parenthesized, comma-separated list of the constructor's formal parameter types. For example:

          public java.util.Hashtable(int,float)

  The only possible modifiers for constructors are the access modifiers `public`, `protected` or `private`. Only one of these may appear, or none if the constructor has default (package) access.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the object.

### newInstance

    public Object newInstance(Object[] initargs)
                       throws InstantiationException,
                              IllegalAccessException,
                              IllegalArgumentException,
                              InvocationTargetException

  Uses the constructor represented by this `Constructor` object to create and initialize a new instance of the constructor's declaring class, with the specified initialization parameters. Individual parameters are automatically unwrapped to match primitive formal parameters, and both primitive and reference parameters are subject to method invocation conversions as necessary.

  If the number of formal parameters required by the underlying constructor is 0, the supplied `initargs` array may be of length 0 or null.

  If the required access and argument checks succeed and the instantiation will proceed, the constructor's declaring class is initialized if it has not already been initialized.

  If the constructor completes normally, returns the newly created and initialized instance.

  Parameters:
    `initargs` - array of objects to be passed as arguments to the constructor call; values of primitive types are wrapped in a wrapper object of the appropriate type (e.g. a `float` in a `Float`)
  Returns:
    a new object created by calling the constructor this object represents
  Throws:
    `IllegalAccessException` - if this `Constructor` object enforces Java language access control and the underlying constructor is inaccessible.
    `IllegalArgumentException` - if the number of actual and formal parameters differ; if an unwrapping conversion for primitive arguments fails; or if, after possible unwrapping, a parameter value cannot be converted to the corresponding formal parameter type by a method invocation conversion.
    `InstantiationException` - if the class that declares the underlying constructor represents an abstract class.
    `InvocationTargetException` - if the underlying constructor throws an exception.
    `ExceptionInInitializerError` - if the initialization provoked by this method fails.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2003 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.